// A C++ program that illustrates declaring
// and accessing array elements

#include <iostream.h>
#include <iomanip.h>
#include <math.h>

const int MAX_ELEMS = 10;

class myArray
{
  public:
    myArray(double fInitVal = 0);
    double& operator[](int nIndex)
      { return m_fArray[nIndex]; }
    void show(const char* pszMsg = "",
              const int nNumElems = MAX_ELEMS,
              const int bOneLine = 1);

  protected:
    double m_fArray[MAX_ELEMS];
};

myArray::myArray(double fInitVal)
{
  for (int i = 0; i < MAX_ELEMS; i++)
    m_fArray[i] = fInitVal;
}

void myArray::show(const char* pszMsg,
                   const int nNumElems,
                   const int bOneLine)
{
  cout << pszMsg << endl;
  if (bOneLine) {
    for (int i = 0; i < nNumElems; i++)
      cout << m_fArray[i] << ' ';
    cout << endl;
  }
  else {
    for (int i = 0; i < nNumElems; i++)
      cout << m_fArray[i] << endl;
    cout << endl;
  }
}

main()
{
  double fXArr[MAX_ELEMS];
  myArray Array;

  // initialize array fXArr
  for (int i = 0; i < MAX_ELEMS; i++)
    fXArr[i] = 2.0 + (double)i;

  // assign values to object Array
  for (i = 0; i < MAX_ELEMS; i++)
    Array[i] = sqrt(fXArr[i]);

  cout.precision(2);

  // show the array
  Array.show("Initial array is:");

  cout << endl;

  // double the values in object Array
  for (i = 0; i < MAX_ELEMS; i++)
    Array[i] += Array[i];

  // show the array
  Array.show("After doubling values, array is:");

  return 0;
}

