// A C++ program that illustrates initializing array elements

#include <iostream.h>
#include <iomanip.h>

const int MAX_ELEMS = 10;

class myArray
{
  public:
    myArray(int bUseInitArray = 1, double fInitVal = 0);
    double& operator[](int nIndex)
      { return m_fArray[nIndex]; }
    void show(const char* pszMsg = "",
              const int nNumElems = MAX_ELEMS,
              const int bOneLine = 1);

  protected:
    double m_fArray[MAX_ELEMS];
};

myArray::myArray(int bUseInitArray, double fInitVal)
{
  // use initializing array
  if (bUseInitArray) {
    double fInitArr[] =
        { 0.1, 0.2, 0.3, 0.4, 0.5,
          0.6, 0.7, 0.8, 0.9, 1.0 };
    for (int i = 0; i < MAX_ELEMS; i++)
      m_fArray[i] = fInitArr[i];
  }
  else
    for (int i = 0; i < MAX_ELEMS; i++)
      m_fArray[i] = fInitVal;
}

void myArray::show(const char* pszMsg,
                   const int nNumElems,
                   const int bOneLine)
{
  cout << pszMsg << endl;
  if (bOneLine) {
    for (int i = 0; i < nNumElems; i++)
      cout << m_fArray[i] << ' ';
    cout << endl;
  }
  else {
    for (int i = 0; i < nNumElems; i++)
      cout << m_fArray[i] << endl;
    cout << endl;
  }
}

main()
{
  double fXArr1[MAX_ELEMS] = { 2.3, 4.5, 8.9, 7.4, 5.1,
                               1.8, 8.7, 6.3, 3.6, 0.8 };
  double fXArr2[] = { 32.3, 24.5, 84.9, 27.4, 65.1,
                      51.8, 88.7, 96.3, 43.6, 30.8 };
  int nNumElems = sizeof(fXArr2) / sizeof(double);
  int nMinNum = (nNumElems > MAX_ELEMS) ?
                 MAX_ELEMS : nNumElems;
  myArray Array;


  cout.precision(4);

  // show the array
  Array.show("Initial array is:");

  // update values to object Array
  for (int i = 0; i < nMinNum; i++)
    Array[i] += fXArr2[i] / fXArr1[i];

  // show the array
  Array.show("New array is:");

  return 0;
}

