// A C++ program that illustrates array parameters

#include <iostream.h>
#include <iomanip.h>

const int MAX_ELEMS = 10;
const int MAX_ARRAY = 20;

void bubbleSort1(int nArray[MAX_ELEMS],
                 int nNumElems = MAX_ELEMS);
void bubbleSort2(int nArray[], int nNumElems);
void copyArray(int nSourceArray[], int nTargetArray[],
               int nNumElems);
void showArray(const char* pszMsg, int nArray[], int nNumElems);

main()
{
  int nArray1[MAX_ELEMS] = { 41, 67, 55, 98, 12,
                             15, 10, 65, 48, 32 };
  int nArray2[MAX_ARRAY];

  // copy elements of array nArray1 into  nArray2
  copyArray(nArray1, nArray2, MAX_ELEMS);

  // display unsorted array nArray1
  showArray("Unsorted array nArray1 is:\n", nArray1, MAX_ELEMS);
  // sort array nArray1
  bubbleSort1(nArray1);
  // display sorted array nArray1
  showArray("Sorted array nArray1 is:\n", nArray1, MAX_ELEMS);

  // copy elements of array nArray2 into  nArray1
  copyArray(nArray2, nArray1, MAX_ELEMS);
  // display unsorted array nArray1
  showArray("Unsorted array nArray1 is:\n", nArray1, MAX_ELEMS);
  // sort array nArray1
  bubbleSort2(nArray1, MAX_ELEMS);
  // display sorted array nArray1
  showArray("Sorted array nArray1 is:\n", nArray1, MAX_ELEMS);
  // sort array nArray2
  bubbleSort2(nArray2, MAX_ELEMS);
  // display sorted array nArray2
  showArray("Sorted array nArray2 is:\n", nArray2, MAX_ELEMS);

  return 0;
}

void bubbleSort1(int nArray[MAX_ELEMS],
                 int nNumElems)
{
  for (int i = 0; i < (nNumElems - 1); i++)
    for (int j = i; j < nNumElems; j++)
      if (nArray[i] > nArray[j]) {
        int nSwap = nArray[i];
        nArray[i] = nArray[j];
        nArray[j] = nSwap;
      }
}

void bubbleSort2(int nArray[], int nNumElems)
{
  for (int i = 0; i < (nNumElems - 1); i++)
    for (int j = i; j < nNumElems; j++)
      if (nArray[i] > nArray[j]) {
        int nSwap = nArray[i];
        nArray[i] = nArray[j];
        nArray[j] = nSwap;
      }
}

void copyArray(int nSourceArray[], int nTargetArray[],
               int nNumElems)
{
  for (int i = 0; i < nNumElems; i++)
    nTargetArray[i] = nSourceArray[i];
}

void showArray(const char* pszMsg, int nArray[], int nNumElems)
{
  cout << pszMsg;
  for (int i = 0; i < nNumElems; i++)
    cout << nArray[i] << ' ';
  cout << endl;
}

