// A C++ program that illustrates
// the quicksort algorithm

#include <iostream.h>
#include <iomanip.h>

const int MAX_ELEMS = 10;

class myArray
{
  public:
    myArray(int fInitVal = 0);
    int& operator[](int nIndex)
      { return m_nArray[nIndex]; }
    void show(const char* pszMsg = "",
              const int nNumElems = MAX_ELEMS,
              const int bOneLine = 1);
    void QuickSort(int nNumElems = MAX_ELEMS);

  protected:
    int m_nArray[MAX_ELEMS];

    void QSort(int nFirst, int nLast);
};

myArray::myArray(int fInitVal)
{
  for (int i = 0; i < MAX_ELEMS; i++)
    m_nArray[i] = fInitVal;
}

void myArray::show(const char* pszMsg,
                   const int nNumElems,
                   const int bOneLine)
{
  cout << pszMsg << endl;
  if (bOneLine) {
    for (int i = 0; i < nNumElems; i++)
      cout << m_nArray[i] << ' ';
    cout << endl;
  }
  else {
    for (int i = 0; i < nNumElems; i++)
      cout << m_nArray[i] << endl;
    cout << endl;
  }
}

void myArray::QuickSort(int nNumElems)
{
  if (nNumElems > 1)
    QSort(0, nNumElems - 1);
}

void myArray::QSort(int nFirst, int nLast)
{
  int i = nFirst, j = nLast;
  int nMedian;

  // obtain the median element
  nMedian = m_nArray[(nFirst + nLast) / 2];
  do {
    while (m_nArray[i] < nMedian)
      i++;
    while (nMedian < m_nArray[j])
      j--;
    if (i <= j) {
      // swap elements
      int nSwap = m_nArray[i];
      m_nArray[i++] = m_nArray[j];
      m_nArray[j--] = nSwap;
    }
  } while (i <= j);

  if (nFirst < j)
    QSort(nFirst, j);

  if (i < nLast)
    QSort(i, nLast);
}

main()
{
  int nArr[MAX_ELEMS] = { 23, 45, 89, 74, 51,
                          18, 87, 63, 36, 38 };
  myArray Array;

  for (int i = 0; i < MAX_ELEMS; i++)
    Array[i] = nArr[i];

  Array.show("Unsorted array is:");
  Array.QuickSort();
  Array.show("Sorted array is:");

  return 0;
}

