// A C++ program that illustrates
// the linear search algorithm

#include <iostream.h>
#include <iomanip.h>

const int MAX_ELEMS = 10;
const int NOT_FOUND = -1;

class myArray
{
  public:
    myArray(int fInitVal = 0);
    int& operator[](int nIndex)
      { return m_nArray[nIndex]; }
    void show(const char* pszMsg = "",
              const int nNumElems = MAX_ELEMS,
              const int bOneLine = 1);
    int linearSearch(int nKey,
                     int nLast = MAX_ELEMS - 1,
                     int nFirst = 0);

  protected:
    int m_nArray[MAX_ELEMS];
};

myArray::myArray(int fInitVal)
{
  for (int i = 0; i < MAX_ELEMS; i++)
    m_nArray[i] = fInitVal;
}

void myArray::show(const char* pszMsg,
                   const int nNumElems,
                   const int bOneLine)
{
  cout << pszMsg << endl;
  if (bOneLine) {
    for (int i = 0; i < nNumElems; i++)
      cout << m_nArray[i] << ' ';
    cout << endl;
  }
  else {
    for (int i = 0; i < nNumElems; i++)
      cout << m_nArray[i] << endl;
    cout << endl;
  }
}

int myArray::linearSearch(int nKey, int nLast, int nFirst)
{
  for (int i = nFirst; i <= nLast; i++)
    if (m_nArray[i] == nKey)
      break;
  return (i <= nLast) ? i : NOT_FOUND;
}

main()
{
  int j;
  int nArr[MAX_ELEMS] = { 23, 45, 89, 74, 51,
                          18, 87, 63, 36, 38 };
  myArray Array;

  for (int i = 0; i < MAX_ELEMS; i++)
    Array[i] = nArr[i];

  Array.show("Array is:");
  for (i = 0; i < MAX_ELEMS; i += 3) {
    cout << "Searching for " << nArr[i];
    j = Array.linearSearch(nArr[i]);
    if (j != NOT_FOUND)
      cout << " found match at index " << j << endl;
    else
      cout << " found no match\n";
  }
  return 0;
}

