// A C++ program that illustrates classes

#include <iostream.h>

class Rectangle
{
  public:                                     
    // constructor
    Rectangle(double fLength = 0, double fWidth = 0);
   
    // query data members
    double getLength();
    double getWidth();  
   
    // set data members
    void setLength(double fLength);
    void setWidth(double fWidth);
   
    // return calculated attribute
    double getArea();
 
  protected:
    double m_fLength; // length
    double m_fWidth;  // width
};


Rectangle::Rectangle(double fLength, double fWidth)
{
  m_fLength = fLength;
  m_fWidth = fWidth;
}

double Rectangle::getLength()
{
  return m_fLength;
}

double Rectangle::getWidth()
{
  return m_fWidth;
}
  
void Rectangle::setLength(double fLength)
{
  m_fLength = fLength;

}

void Rectangle::setWidth(double fWidth)
{
  m_fWidth = fWidth;
}
   
double Rectangle::getArea()
{
  return m_fLength * m_fWidth;
}

main()
{
  Rectangle rect(10.212, 20.543);
 
  // display current dimensions and area
  cout << "Length = " << rect.getLength() << "\n";
  cout << "Width  = " << rect.getWidth() << "\n";
  cout << "Area   = " << rect.getArea() << "\n";
  cout << "\n";
 
  // set new dimensions
  rect.setLength(5.142);
  rect.setWidth(15.453);

  // display current dimensions and area
  cout << "Length = " << rect.getLength() << "\n";
  cout << "Width  = " << rect.getWidth() << "\n";
  cout << "Area   = " << rect.getArea() << "\n";

  return 0;
}

