// A C++ program that illustrates classes with
// inline definitions of member functions

#include <iostream.h>

class Rectangle
{
  public:                                     
    // constructor
    Rectangle(double fLength = 0, double fWidth = 0);
   
    // query data members
    double getLength() { return m_fLength; }
    double getWidth() { return m_fWidth; }  
   
    // set data members
    void setLength(double fLength) { m_fLength = fLength; }
    void setWidth(double fWidth) { m_fWidth = fWidth; }
   
    // return calculated attribute
    double getArea() { return m_fLength * m_fWidth; }
 
  protected:
    double m_fLength; // length
    double m_fWidth;  // width
};


Rectangle::Rectangle(double fLength, double fWidth)
{
  m_fLength = fLength;
  m_fWidth = fWidth;
}

main()
{
  Rectangle rect(10.212, 20.543);
 
  // display current dimensions and area
  cout << "Length = " << rect.getLength() << "\n";
  cout << "Width  = " << rect.getWidth() << "\n";
  cout << "Area   = " << rect.getArea() << "\n";
  cout << "\n";
 
  // set new dimensions
  rect.setLength(5.142);
  rect.setWidth(15.453);

  // display current dimensions and area
  cout << "Length = " << rect.getLength() << "\n";
  cout << "Width  = " << rect.getWidth() << "\n";
  cout << "Area   = " << rect.getArea() << "\n";

  return 0;
}

