// A C++ program that illustrates child classes

#include <iostream.h>

class Rectangle
{
  public:                                     
    // constructor
    Rectangle(double fLength = 0, double fWidth = 0);
   
    // query data members
    double getLength() { return m_fLength; }
    double getWidth() { return m_fWidth; }  
   
    // set data members
    void setLength(double fLength) { m_fLength = fLength; }
    void setWidth(double fWidth) { m_fWidth = fWidth; }
   
    // return calculated attribute
    double getArea() { return m_fLength * m_fWidth; }
 
  protected:
    double m_fLength; // length
    double m_fWidth;  // width
};

class Solid : public Rectangle
{
  public:
    // constructor
    Solid(double fLength = 0,
          double fWidth = 0,
          double fHeight = 0);
 
    // query data members
    double getHeight() { return m_fHeight; }
   
    // set data members
    void setHeight(double fHeight) { m_fHeight = fHeight; }
   
    // return calculated attribute
    double getVolume() { return m_fHeight * getArea(); }
 
 
  protected:
    double m_fHeight;
};

Rectangle::Rectangle(double fLength, double fWidth)
{
  m_fLength = fLength;
  m_fWidth = fWidth;
}

Solid::Solid(double fLength, double fWidth, double fHeight)
{
  m_fLength = fLength;
  m_fWidth = fWidth;
  m_fHeight = fHeight;
}

main()
{
  Solid Brick(3.5, 2.5, 1.5);
 
  // display current dimensions, area, and volume
  cout << "Length = " << Brick.getLength() << "\n";
  cout << "Width  = " << Brick.getWidth() << "\n";
  cout << "Height = " << Brick.getHeight() << "\n";
  cout << "Area   = " << Brick.getArea() << "\n";
  cout << "Volume = " << Brick.getVolume() << "\n";
 
  cout << "\n";
 
  // set new dimensions
  Brick.setLength(5.5);
  Brick.setWidth(7.5);
  Brick.setHeight(4.5);              
 
  // display current dimensions, area, and volume
  cout << "Length = " << Brick.getLength() << "\n";
  cout << "Width  = " << Brick.getWidth() << "\n";
  cout << "Height = " << Brick.getHeight() << "\n";
  cout << "Area   = " << Brick.getArea() << "\n";
  cout << "Volume = " << Brick.getVolume() << "\n";

  return 0;
}

