// A C++ program that illustrates a simple class
// that models a two-dimensional coordinate system

#include <iostream.h>
#include <math.h>

inline double sqr(double x)
{ return x * x; }

class myPoint
{
  public:
    myPoint();

    void setXCoord(double fX)
      { m_fX = fX; }
    void setYCoord(double fY)
      { m_fY = fY; }
    void copyCoords(const myPoint& otherPoint);
    double getXCoord()
      { return m_fX; }
    double getYCoord()
      { return m_fY; }
    double getDistance(const myPoint& otherPoint)
      { return sqrt(sqr(m_fX - otherPoint.m_fX) +
                    sqr(m_fY - otherPoint.m_fY)); }
    double getDistanceFromOrigin()
      { return sqrt(sqr(m_fX) + sqr(m_fY)); }

  protected:
    double m_fX;
    double m_fY;
};

myPoint::myPoint()
{
  m_fX = 0.;
  m_fY = 0.;
}

void myPoint::copyCoords(const myPoint& otherPoint)
{
  m_fX = otherPoint.m_fX;
  m_fY = otherPoint.m_fY;
}

main()
{
  myPoint objPt1;
  myPoint objPt2;
  double fX = 10.5;
  double fY = 45.6;

  // assign coordinates to object objPt1
  objPt1.setXCoord(fX);
  objPt1.setYCoord(fY);

  // assign coordinates to object objPt2
  objPt2.setXCoord(2.3 * fX);
  objPt2.setYCoord(2.9 * fY);

  // show coordinates of object objPt1
  cout << "Object 1 is at ("
       << objPt1.getXCoord() << ", "
       << objPt1.getYCoord() << ")\n";

  // show coordinates of object objPt2
  cout << "Object 2 is at ("
       << objPt2.getXCoord() << ", "
       << objPt2.getYCoord() << ")\n";

  // show distance between object objPt1 and origin
  cout << "Distance between object 1 and origin = "
       << objPt1.getDistanceFromOrigin() << "\n";

  // show distance between object objPt2 and origin
  cout << "Distance between object 2 and origin = "
       << objPt2.getDistanceFromOrigin() << "\n";

  // show distance between objects objPt1 and objPt2
  cout << "Distance between objects = "
       << objPt1.getDistance(objPt2) << "\n\n";

  // copy coordinates
  objPt2.copyCoords(objPt1);

  // show new coordinates of object objPt2
  cout << "Object 2 has moved to ("
       << objPt2.getXCoord() << ", "
       << objPt2.getYCoord() << ")\n";

  // show new distance between objects objPt1 and objPt2
  cout << "New distance between objects = "
       << objPt1.getDistance(objPt2) << "\n";

  return 0;
}

