// A C++ program that illustrates a class
// that uses multiple constructors

#include <iostream.h>
#include <math.h>

inline double sqr(double x)
{ return x * x; }

class myPoint
{
  public:
    myPoint();
    myPoint(const myPoint& otherPoint)
      { copyCoords(otherPoint); }
    myPoint(double fX, double fY);

    void setXCoord(double fX)
      { m_fX = fX; }
    void setYCoord(double fY)
      { m_fY = fY; }
    void copyCoords(const myPoint& otherPoint);
    double getXCoord()
      { return m_fX; }
    double getYCoord()
      { return m_fY; }
    double getDistance(const myPoint& otherPoint)
      { return sqrt(sqr(m_fX - otherPoint.m_fX) +
                    sqr(m_fY - otherPoint.m_fY)); }
    double getDistanceFromOrigin()
      { return sqrt(sqr(m_fX) + sqr(m_fY)); }

  protected:
    double m_fX;
    double m_fY;
};

myPoint::myPoint()
{
  m_fX = 0.;
  m_fY = 0.;
}

myPoint::myPoint(double fX, double fY)
{
  m_fX = fX;
  m_fY = fY;
}

void myPoint::copyCoords(const myPoint& otherPoint)
{
  m_fX = otherPoint.m_fX;
  m_fY = otherPoint.m_fY;
}

main()
{
  double fX = 10.5;
  double fY = 45.6;
  myPoint objPt1;
  myPoint objPt2(2.3 * fX, 2.9 * fY);
  myPoint objPt3(objPt2);

  // assign coordinates to object objPt1
  objPt1.setXCoord(fX);
  objPt1.setYCoord(fY);

  // show coordinates of object objPt1
  cout << "Object 1 is at ("
       << objPt1.getXCoord() << ", "
       << objPt1.getYCoord() << ")\n";

  // show coordinates of object objPt2
  cout << "Object 2 is at ("
       << objPt2.getXCoord() << ", "
       << objPt2.getYCoord() << ")\n";

  // show coordinates of object objPt3
  cout << "Object 3 is at ("
       << objPt3.getXCoord() << ", "
       << objPt3.getYCoord() << ")\n";

  // show distance between object objPt1 and origin
  cout << "Distance between object 1 and origin = "
       << objPt1.getDistanceFromOrigin() << "\n";

  // show distance between object objPt2 and origin
  cout << "Distance between object 2 and origin = "
       << objPt2.getDistanceFromOrigin() << "\n";

  // show distance between object objPt3 and origin
  cout << "Distance between object 3 and origin = "
       << objPt3.getDistanceFromOrigin() << "\n";

  // show distance between objects objPt1 and objPt2
  cout << "Distance between objects 1 and 2 = "
       << objPt1.getDistance(objPt2) << "\n";

  // show distance between objects objPt1 and objPt3
  cout << "Distance between objects 1 and 3 = "
       << objPt1.getDistance(objPt3) << "\n\n";

  return 0;
}

