// A C++ program that illustrates a class
// that uses constructors for data conversion

#include <iostream.h>
#include <math.h>

inline double sqr(double x)
{ return x * x; }

class myPoint
{
  public:
    myPoint(double fX = 0., double fY = 0.);

    void setXCoord(double fX)
      { m_fX = fX; }
    void setYCoord(double fY)
      { m_fY = fY; }
    double getXCoord()
      { return m_fX; }
    double getYCoord()
      { return m_fY; }
    double getDistance(const myPoint& otherPoint)
      { return sqrt(sqr(m_fX - otherPoint.m_fX) +
                    sqr(m_fY - otherPoint.m_fY)); }
    double getDistanceFromOrigin()
      { return sqrt(sqr(m_fX) + sqr(m_fY)); }

  protected:
    double m_fX;
    double m_fY;
};

myPoint::myPoint(double fX, double fY)
{
  m_fX = fX;
  m_fY = fY;
}

main()
{
  double fX = 10.5;
  double fY = 45.6;
  myPoint objPt1(fX, fY);

  // show coordinates of object objPt1
  cout << "Object 1 is at ("
       << objPt1.getXCoord() << ", "
       << objPt1.getYCoord() << ")\n";

  // show distance between object objPt1 and origin
  cout << "Distance between object 1 and origin = "
       << objPt1.getDistanceFromOrigin() << "\n";

  fX = 10.;
  fY = 10.;
  // show distance between objects objPt1 and (fX, fY)
  cout << "Distance between objects 1 and ("
       << fX << ", " << fY << ") = "
       << objPt1.getDistance(myPoint(fX, fY)) << "\n";

  return 0;
}

