// A C++ program that illustrates
// the use of the operator << with
// user-defined classes

#include <iostream.h>
#include <math.h>

inline double sqr(double x)
{ return x * x; }

class myPoint
{
  public:
    myPoint(double fX = 0., double fY = 0.);

    void setXCoord(double fX)
      { m_fX = fX; }
    void setYCoord(double fY)
      { m_fY = fY; }
    double getXCoord()
      { return m_fX; }
    double getYCoord()
      { return m_fY; }
    double getDistance(const myPoint& otherPoint)
      { return sqrt(sqr(m_fX - otherPoint.m_fX) +
                    sqr(m_fY - otherPoint.m_fY)); }
    double getDistanceFromOrigin()
      { return sqrt(sqr(m_fX) + sqr(m_fY)); }
     friend ostream& operator <<(ostream& os, myPoint& aPoint);

  protected:
    double m_fX;
    double m_fY;
};

myPoint::myPoint(double fX, double fY)
{
  m_fX = fX;
  m_fY = fY;
}

ostream& operator <<(ostream& os, myPoint& aPoint)
{
  os << "(" << aPoint.getXCoord() << ", "
     << aPoint.getYCoord() << ")";

  return os;
}

main()
{
  double fX = 10.5;
  double fY = 45.6;
  myPoint objPt1(fX, fY);
  myPoint objPt2(2.1 * fX, 2.3 * fY);

  // show coordinates of object objPt1
  cout << "Object 1 is at " << objPt1 << "\n";

  // show coordinates of object objPt2
  cout << "Object 2 is at " << objPt2 << "\n";

  // show distance between object objPt1 and origin
  cout << "Distance between object 1 and origin = "
       << objPt1.getDistanceFromOrigin() << "\n";

  // show distance between object objPt2 and origin
  cout << "Distance between object 2 and origin = "
       << objPt2.getDistanceFromOrigin() << "\n";

  // show distance between objects objPt1 and objPt2
  cout << "Distance between objects 1 and 2 = "
       << objPt1.getDistance(objPt2) << "\n";

  return 0;
}

