// A C++ program that illustrates the continue statement

#include <iostream.h>
#include <stdio.h>
#include <math.h>

const double EPSILON = 1.0e-50;
const double BAD_RESULT = -1.0e+30;

class SumPoly
{
  public:
    SumPoly(const int nFirst, const int nLast)
      { setParams(nFirst, nLast); }
    void setParams(const int nFirst, const int nLast);

    double polynomial(double x);

  protected:
    int m_nFirst;
    int m_nLast;
};

void SumPoly::setParams(const int nFirst, const int nLast)
{
  if (nFirst < nLast) {
    m_nFirst = nFirst;
    m_nLast = nLast;
  }
  else {
    m_nFirst = nLast;
    m_nLast = nFirst;
  }
}

double SumPoly::polynomial(double x)
{
  double fSum = 0;
  double fTerm;

  if (fabs(x) < EPSILON)
    return BAD_RESULT;

  for (int i = m_nFirst; i <= m_nLast; i++) {
    if (i == 0)
      continue;
    // calculate term
    fTerm = pow(x, i) / (i * i);
    // update summation
    fSum += fTerm;
  }

  return fSum;
}

main()
{
  const double LO = 1.0;
  const double HI = 2.0;
  const double INCR = 0.25;
  const int FIRST = -3;
  const int LAST = 3;
  SumPoly Poly(FIRST, LAST);
  double fX = LO;
  char cFrmt[30];

  cout << "P(X) = ";
  for (int i = FIRST; i <= LAST; i++) {
    if (i == 0)
      continue;
    if (i > FIRST)
      cout << " + ";
    cout << "X";
    if (i != 1) {
      if (i > 0)
        cout << "^" << i;
      else
        cout << "^(" << i << ")";
    }
    if ((i * i) != 1)
      cout << "/" << (i * i);
  }
  cout << "\n\n";
  while (fX <= HI) {
    sprintf(cFrmt, "P(%5.3lf) = %lf\n", fX, Poly.polynomial(fX));
    cout << cFrmt;
    fX += INCR;
  }

  return 0;
}

