// A C++ program that illustrates
// creating a new class as a public
// descendant of a parent class

#include <iostream.h>
#include <iomanip.h>

const int MAX_ELEMS = 10;

enum Logical { FALSE, TRUE };

class myArray
{
  public:
    myArray(int nNumElems = MAX_ELEMS, int fInitVal = 0);
    ~myArray()
      { delete [] m_pnArray; }
    int& operator[](int nIndex)
      { return m_pnArray[nIndex]; }
    void show(const char* pszMsg = "",
              const int nNumElems = MAX_ELEMS);

  protected:
    int* m_pnArray;
    int m_nNumElems;
};

class mySortedArray : public myArray
{
  public:
    void CombSort(int nNumElems);

};

myArray::myArray(int nNumElems, int fInitVal)
{
  m_nNumElems = (nNumElems > 0) ? nNumElems : 1;
  m_pnArray = new int[m_nNumElems];
  for (int i = 0; i < m_nNumElems; i++)
    m_pnArray[i] = fInitVal;
}

void myArray::show(const char* pszMsg,
                   const int nNumElems)
{
  cout << pszMsg << endl;
  for (int i = 0; i < nNumElems; i++)
    cout << m_pnArray[i] << ' ';
  cout << endl;
}

void mySortedArray::CombSort(int nNumElems)
{
  int nOffset = nNumElems;
  Logical bSorted;

  if (nNumElems < 2)
    return;

  do {
    nOffset = (nOffset * 8) / 11;
    nOffset = (nOffset < 1) ? 1 : nOffset;
    bSorted = TRUE; // set sorted flag
    // compare elements
    for (int i = 0, j = nOffset;
         i < (nNumElems - nOffset);
         i++, j++) {
      if (m_pnArray[i] > m_pnArray[j]) {
        // swap elements
        int nSwap = m_pnArray[i];
        m_pnArray[i] = m_pnArray[j];
        m_pnArray[j] = nSwap;
        bSorted = FALSE; // clear sorted flag
      }
    }
  } while (!bSorted || nOffset != 1);
}

main()
{
  int nArr[MAX_ELEMS] = { 23, 45, 89, 74, 51,
                          18, 87, 63, 36, 38 };
  mySortedArray Array;

  for (int i = 0; i < MAX_ELEMS; i++)
    Array[i] = nArr[i];

  Array.show("Unsorted array is:");
  Array.CombSort(MAX_ELEMS);
  Array.show("Sorted array is:");

  return 0;
}

