// A C++ program that illustrates
// declaring and using friend functions

#include <iostream.h>
#include <string.h>

class myString
{
  public:
    myString(int nSize = 10)
      { m_pszString = new char[m_nSize = nSize]; }
    ~myString()
      { delete [] m_pszString; }
    void assign(const char* pszString);
    void show(const char* pszMsg = "");
    friend int compare(myString& aString1, myString aString2);
    friend int compare(const char* pszString1, myString aString2);
    friend int compare(myString aString1, const char* pszString2);

  protected:
    char* m_pszString;
    int m_nSize;
};

void myString::assign(const char* pszString)
{
  // source string small enough to copy?
  if (strlen(pszString) < unsigned(m_nSize))
    strcpy(m_pszString, pszString);
  else
    // copy first m_nSize characters
    strncpy(m_pszString, pszString, m_nSize);
}

void myString::show(const char* pszMsg)
{
  cout << pszMsg << m_pszString << "\n";
}

int compare(myString& aString1, myString aString2)
{
  return strcmp(aString1.m_pszString, aString2.m_pszString);
}

int compare(const char* pszString1, myString aString2)
{
  return strcmp(pszString1, aString2.m_pszString);
}

int compare(myString aString1, const char* pszString2)
{
  return strcmp(aString1.m_pszString, pszString2);
}

main()
{
  const int MAX_CHARS = 81;
  myString aString1(MAX_CHARS);
  myString aString2(MAX_CHARS);

  char cString1[] = "ABCDEFG";
  char cString2[] = "1234567890";

  aString1.assign(cString1);
  aString2.assign(cString2);

  aString1.show("String object 1 is ");
  aString2.show("String object 2 is ");
  cout << "ASCIIZ string 1 is " << cString1 << "\n";
  cout << "ASCIIZ string 2 is " << cString2 << "\n\n";

  cout << "String objects are ";
  if (compare(aString1, aString2) != 0)
    cout << "not ";
  cout << "equal\n";

  cout << "String object 1 and ASCIIZ string 1 ";
  if (compare(aString1, cString1) != 0)
    cout << "not ";
  cout << "equal\n";

  cout << "String object 1 and ASCIIZ string 2 ";
  if (compare(aString1, cString2) != 0)
    cout << "not ";
  cout << "equal\n";

  cout << "String object 2 and ASCIIZ string 1 ";
  if (compare(cString1, aString2) != 0)
    cout << "not ";
  cout << "equal\n";

  cout << "String object 2 and ASCIIZ string 2 ";
  if (compare(cString2, aString2) != 0)
    cout << "not ";
  cout << "equal\n";

  return 0;
}

