// A C++ program that illustrates
// declaring and using operators

#include <iostream.h>
#include <string.h>

class myString
{
  public:
    myString(int nSize = 10)
      { m_pszString = new char[m_nSize = nSize]; }
    ~myString()
      { delete [] m_pszString; }
    int getLen()
      { return strlen(m_pszString); }
    int getMaxLen()
      { return m_nSize; }
    myString& operator =(myString& aString);
    myString& operator =(const char* pszString);
    myString& operator =(const char cChar);
    myString& operator +=(myString& aString);
    myString& operator +=(const char* pszString);
    myString& operator +=(const char cChar);
    void show(const char* pszMsg = "");

  protected:
    char* m_pszString;
    int m_nSize;
};

myString& myString::operator =(myString& aString)
{
  // source string small enough to copy?
  if (strlen(aString.m_pszString) < unsigned(m_nSize))
    strcpy(m_pszString, aString.m_pszString);
  else
    // copy first m_nSize - 1 characters
    strncpy(m_pszString, aString.m_pszString, m_nSize - 1);
  return *this;
}

myString& myString::operator =(const char* pszString)
{
  // source string small enough to copy?
  if (strlen(pszString) < unsigned(m_nSize))
    strcpy(m_pszString, pszString);
  else
    // copy first m_nSize - 1 characters
    strncpy(m_pszString, pszString, m_nSize - 1);
  return *this;
}

myString& myString::operator =(const char cChar)
{
  if (m_nSize > 1) {
    m_pszString[0] = cChar;
    m_pszString[1] = '\0';
  }
  return *this;
}

myString& myString::operator +=(myString& aString)
{
  // source string small enough to copy?
  if (strlen(aString.m_pszString) + strlen(m_pszString) <=
      unsigned(m_nSize))
    strcat(m_pszString, aString.m_pszString);
  else
    // copy first m_nSize characters
    strncat(m_pszString, aString.m_pszString,
            m_nSize - strlen(m_pszString));
  return *this;
}

myString& myString::operator +=(const char* pszString)
{
  // source string small enough to copy?
  if (strlen(pszString) + strlen(m_pszString) <=
      unsigned(m_nSize))
    strcat(m_pszString, pszString);
  else
    // copy first m_nSize characters
    strncat(m_pszString, pszString,
            m_nSize - strlen(m_pszString));
  return *this;
}

myString& myString::operator +=(const char cChar)
{
  int nWorkSize = strlen(m_pszString);

  // source string small enough to copy?
  if (nWorkSize + 1 <= m_nSize) {
    m_pszString[nWorkSize] = cChar;
    m_pszString[nWorkSize + 1] = '\0';
  }
  return *this;
}

void myString::show(const char* pszMsg)
{
  cout << pszMsg << m_pszString << "\n";
}

main()
{
  const int MAX_CHARS = 81;
  myString aString1(MAX_CHARS);
  myString aString2(MAX_CHARS);
  myString aString3(MAX_CHARS);

  char cString1[] = "ABCDEFG";
  char cString2[] = "1234567890";
  char cChar = '!';

  aString1 = cString1;
  aString2 = aString1;
  aString3 = cChar;

  aString1.show("String object 1 is ");
  aString2.show("String object 2 is ");
  aString3.show("String object 3 is ");

  aString1 = ""; // clear string object 1
  aString1 += cString2; // append ASCIZZ string
  aString1 += aString2; // append string object
  aString1 += cChar; // apend a character
  aString1.show("New string object 1 is ");

  return 0;
}

