// A C++ program illustrates the do-while loop

#include <iostream.h>

const double DEF_TOLR = 1.0e-8;

class myRoot
{
  public:
    myRoot(double fTolerance = 1.0e-8)
      { setRootInfo(fTolerance); }
    void setRootInfo(double fTolerance = DEF_TOLR)
      { m_fTolerance = (fTolerance <= 0) ?
             DEF_TOLR : fTolerance; }
    double getSquareRoot(double fX);
    double getCubeRoot(double fX);

  protected:
    double m_fTolerance;

    double abs(double x)
      { return (x >= 0) ? x : -x; }
};

double myRoot::getSquareRoot(double fX)
{
  double fDiff;
  double fGuess = fX / 2;

  do {
    fDiff = (fGuess * fGuess - fX) / (2 * fGuess);
    fGuess -= fDiff;
  } while (abs(fDiff) > m_fTolerance);

  return fGuess;
}

double myRoot::getCubeRoot(double fX)
{
  double fDiff;
  double fGuess = fX / 2;
  double fSqr;

  do {
    fSqr = fGuess * fGuess;
    fDiff = (fSqr * fGuess - fX) / (3 * fSqr);
    fGuess -= fDiff;
  } while (abs(fDiff) > m_fTolerance);

  return fGuess;
}

main()
{
  double fX;
  myRoot Root;

  for (int i = 0; i < 3; i++) {
    do {
      cout << "Enter a positive number : ";
      cin >> fX;
    } while (fX <= 0);
    cout << "Square root of " << fX << " = "
         << Root.getSquareRoot(fX) << "\n"
         << "Cube root of " << fX << " = "
         << Root.getCubeRoot(fX) << "\n\n";
  }

  return 0;

}

