// A C++ program that illustrates simple enumerated types

#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <time.h>

const int TRUE = 1;
const int FALSE = 0;
typedef int Logical;

// declare enumerated type
enum weekDay { Sunday, Monday, Tuesday, Wednesday,
               Thursday, Friday, Saturday };

class myDay
{
  public:
    // constructor
    myDay(int nDayNum = 0)
      { setDay(nDayNum); }

    void show(const char* pszMsg = "",
              Logical bEmitCR = TRUE);
    void setDay(int nDayNum);
    weekDay getDay()
      { return m_eDay; }
    void getNext();
    void getPrevious();

  protected:
    weekDay m_eDay;
};

void myDay::show(const char* pszMsg, Logical bEmitCR)
{
  cout << pszMsg;
  switch (m_eDay) {
    case Sunday:
      cout << "Sunday";
      break;

    case Monday:
      cout << "Monday";
      break;

    case Tuesday:
      cout << "Tuesday";
      break;

    case Wednesday:
      cout << "Wednesday";
      break;

    case Thursday:
      cout << "Thursday";
      break;

    case Friday:
      cout << "Friday";
      break;

    case Saturday:
      cout << "Saturday";
      break;
  }

  if (bEmitCR)
    cout << endl;
}

void myDay::setDay(int nDayNum)
{
  // translate integer day number
  // into enumerated value
  switch (nDayNum) {
    case 0:
      m_eDay = Sunday;
      break;

    case 1:
      m_eDay = Monday;
      break;

    case 2:
      m_eDay = Tuesday;
      break;

    case 3:
      m_eDay = Wednesday;
      break;

    case 4:
      m_eDay = Thursday;
      break;

    case 5:
      m_eDay = Friday;
      break;

    case 6:
      m_eDay = Saturday;
      break;

    default:
      m_eDay = Sunday;
  }
}

void myDay::getNext()
{
  switch (m_eDay) {
    case Sunday:
      m_eDay = Monday;
      break;

    case Monday:
      m_eDay = Tuesday;
      break;

    case Tuesday:
      m_eDay = Wednesday;
      break;

    case Wednesday:
      m_eDay = Thursday;
      break;

    case Thursday:
      m_eDay = Friday;
      break;

    case Friday:
      m_eDay = Saturday;
      break;

    case Saturday:
      m_eDay = Sunday;
      break;
  }
}

void myDay::getPrevious()
{
  switch (m_eDay) {
    case Sunday:
      m_eDay = Saturday;
      break;

    case Monday:
      m_eDay = Sunday;
      break;

    case Tuesday:
      m_eDay = Monday;
      break;

    case Wednesday:
      m_eDay = Tuesday;
      break;

    case Thursday:
      m_eDay = Wednesday;
      break;

    case Friday:
      m_eDay = Thursday;
      break;

    case Saturday:
      m_eDay = Friday;
      break;
  }
}

main()
{
  const int MAX = 3;
  myDay makeMyDay;

  // reseed random-number generator
  srand((unsigned)time(NULL));
  for (int i = 0; i < MAX; i++) {
    // get random day number
    int n = rand() % 7;
    makeMyDay.setDay(n);
    // display today
    cout << "Day # " << (i+1) << endl;
    makeMyDay.show("Today is ");

    // display tomorrow
    makeMyDay.getNext();
    makeMyDay.show("Tomorrow is ");

    // display yesterday
    makeMyDay.getPrevious(); // back to today
    makeMyDay.getPrevious();
    makeMyDay.show("Yesterday was ");
    cout << endl;
  }

  return 0;
}

