// C++ program that illustrates using
// enumerated types with explicit values

#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <time.h>

const int TRUE = 1;
const int FALSE = 0;
typedef int Logical;

// declare enumerated type
enum digitEnum { Nine = 9, Eight = 8, Seven = 7, Six = 6,
                 Five = 5, Zero = 0, One, Two, Three, Four };

class myDigit
{
  public:
    // constructor
    myDigit(int nDigit = 0)
      { setDigit(nDigit); }

    void show(const char* pszMsg = "",
              Logical bEmitCR = TRUE);
    void setDigit(int nDigit)
      { m_eDigit = digitEnum(nDigit); }
    digitEnum getDigit()
      { return m_eDigit; }
    void getNext();
    void getPrevious();
    Logical isEqual(int nDigit)
     { return (m_eDigit == nDigit) ? TRUE : FALSE; }

  protected:
    digitEnum m_eDigit;
};

void myDigit::show(const char* pszMsg, Logical bEmitCR)
{
  cout << pszMsg << int(m_eDigit);

  if (bEmitCR)
    cout << endl;
}


void myDigit::getNext()
{
  if (m_eDigit != Nine)
    m_eDigit = digitEnum(int(m_eDigit) + 1);
  else
    m_eDigit = Zero;
}

void myDigit::getPrevious()
{
  if (m_eDigit != Zero)
    m_eDigit = digitEnum(int(m_eDigit) - 1);
  else
    m_eDigit = Nine;
}

main()
{
  const int MAX = 3;
  const int HI_NUM = 10;
  myDigit OneDigit;

  // reseed random-number generator
  srand((unsigned)time(NULL));
  for (int i = 0; i < MAX; i++) {
    // get random number
    int n = rand() % HI_NUM ;
    OneDigit.setDigit(n);
    // display digit
    cout << "Digit # " << (i+1) << endl;
    OneDigit.show("Digit is ");

    // display next digit
    OneDigit.getNext();
    OneDigit.show("Next digit is ");

    // display previous digit
    OneDigit.getPrevious(); // back to current digit
    OneDigit.getPrevious();
    OneDigit.show("Previous digit is ");
    OneDigit.getNext(); // back to "current" digit
    cout << "Digit equals to 5? "
         << (OneDigit.isEqual(HI_NUM / 2) ? "true" : "false")
         << "\n\n";
  }

  return 0;
}

