// A C++ program that illustrates
// enumerated types nested in classes

#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <time.h>

const int TRUE = 1;
const int FALSE = 0;
typedef int Logical;


class myWeekDays
{
  public:
    enum weekDays { Sunday, Monday, Tuesday, Wednesday,
                    Thursday, Friday, Saturday };
};

class yourWeekDays
{
  public:
    enum weekDays { Sunday, Monday, Tuesday, Wednesday,
                    Thursday, Friday, Saturday };
};

class myDay
{
  public:
    // constructor
    myDay(int nDayNum = 0)
      { setDay(nDayNum); }

    void show(const char* pszMsg = "",
              Logical bEmitCR = TRUE);
    void setDay(int nDayNum);
    myWeekDays::weekDays getDay()
      { return m_eDay; }
    void getNext();
    void getPrevious();

  protected:
    myWeekDays::weekDays m_eDay;
};

class yourDay
{
  public:
    // constructor
    yourDay(int nDayNum = 0)
      { setDay(nDayNum); }

    void show(const char* pszMsg = "",
              Logical bEmitCR = TRUE);
    void setDay(int nDayNum);
    yourWeekDays::weekDays getDay()
      { return m_eDay; }
    void getNext();
    void getPrevious();

  protected:
    yourWeekDays::weekDays m_eDay;
};

//
// Define members of class myDay
//

void myDay::show(const char* pszMsg, Logical bEmitCR)
{
  cout << pszMsg;
  switch (m_eDay) {
    case myWeekDays::Sunday:
      cout << "Sunday";
      break;

    case myWeekDays::Monday:
      cout << "Monday";
      break;

    case myWeekDays::Tuesday:
      cout << "Tuesday";
      break;

    case myWeekDays::Wednesday:
      cout << "Wednesday";
      break;

    case myWeekDays::Thursday:
      cout << "Thursday";
      break;

    case myWeekDays::Friday:
      cout << "Friday";
      break;

    case myWeekDays::Saturday:
      cout << "Saturday";
      break;
  }

  if (bEmitCR)
    cout << endl;
}

void myDay::setDay(int nDayNum)
{
  if ((nDayNum % 8) == 0)
    m_eDay = myWeekDays::weekDays(nDayNum);
  else
    m_eDay = myWeekDays::Sunday;
}

void myDay::getNext()
{
  if (m_eDay != myWeekDays::Saturday)
    m_eDay = myWeekDays::weekDays(int(m_eDay) + 1);
  else
    m_eDay = myWeekDays::Sunday;
}

void myDay::getPrevious()
{
  if (m_eDay != myWeekDays::Sunday)
    m_eDay = myWeekDays::weekDays(int(m_eDay) - 1);
  else
    m_eDay = myWeekDays::Saturday;
}

//
// Define members of class yourDay
//

void yourDay::show(const char* pszMsg, Logical bEmitCR)
{
  cout << pszMsg;
  switch (m_eDay) {
    case yourWeekDays::Sunday:
      cout << "Sunday";
      break;

    case yourWeekDays::Monday:
      cout << "Monday";
      break;

    case yourWeekDays::Tuesday:
      cout << "Tuesday";
      break;

    case yourWeekDays::Wednesday:
      cout << "Wednesday";
      break;

    case yourWeekDays::Thursday:
      cout << "Thursday";
      break;

    case yourWeekDays::Friday:
      cout << "Friday";
      break;

    case yourWeekDays::Saturday:
      cout << "Saturday";
      break;
  }

  if (bEmitCR)
    cout << endl;
}

void yourDay::setDay(int nDayNum)
{
  if ((nDayNum % 8) == 0)
    m_eDay = yourWeekDays::weekDays(nDayNum);
  else
    m_eDay = yourWeekDays::Sunday;
}

void yourDay::getNext()
{
  if (m_eDay != yourWeekDays::Saturday)
    m_eDay = yourWeekDays::weekDays(int(m_eDay) + 1);
  else
    m_eDay = yourWeekDays::Sunday;
}

void yourDay::getPrevious()
{
  if (m_eDay != yourWeekDays::Sunday)
    m_eDay = yourWeekDays::weekDays(int(m_eDay) - 1);
  else
    m_eDay = yourWeekDays::Saturday;
}

main()
{
  const int MAX = 4;
  myDay makeMyDay;
  yourDay makeYourDay;

  // reseed random-number generator
  srand((unsigned)time(NULL));
  for (int i = 0; i < MAX; i++) {
    // get random day number
    int n = rand() % 7;
    if (i < (MAX / 2)) {
      makeMyDay.setDay(n);
      // display today
      cout << "Day # " << (i+1) << endl;
      makeMyDay.show("Today is ");

      // display tomorrow
      makeMyDay.getNext();
      makeMyDay.show("Tomorrow is ");

      // display yesterday
      makeMyDay.getPrevious(); // back to today
      makeMyDay.getPrevious();
      makeMyDay.show("Yesterday was ");
    }
    else {
      makeYourDay.setDay(n);
      // display today
      cout << "Day # " << (i+1) << endl;
      makeYourDay.show("Today is ");

      // display tomorrow
      makeYourDay.getNext();
      makeYourDay.show("Tomorrow is ");

      // display yesterday
      makeYourDay.getPrevious(); // back to today
      makeYourDay.getPrevious();
      makeYourDay.show("Yesterday was ");
    }

    cout << endl;
  }

  return 0;
}

