// A C++ program that illustrates using reference
// enumerated types as function parameters

#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <time.h>

const int TRUE = 1;
const int FALSE = 0;
typedef int Logical;

// declare enumerated type
enum weekDay { Sunday, Monday, Tuesday, Wednesday,
               Thursday, Friday, Saturday };

class myDay
{
  public:
    // constructors
    myDay(weekDay aDay)
      { setDay(aDay); }
    myDay(int nDayNum = 0)
      { setDay(nDayNum); }

    void show(const char* pszMsg = "",
              Logical bEmitCR = TRUE);
    void setDay(int nDayNum);
    void setDay(weekDay aDay)
      { m_eDay = aDay; }
    weekDay getDay()
      { return m_eDay; }
    void getNextAndPrevious(weekDay& eNextDay,
                            weekDay& ePrevDay);

  protected:
    weekDay m_eDay;
};

void myDay::show(const char* pszMsg, Logical bEmitCR)
{
  cout << pszMsg;
  switch (m_eDay) {
    case Sunday:
      cout << "Sunday";
      break;

    case Monday:
      cout << "Monday";
      break;

    case Tuesday:
      cout << "Tuesday";
      break;

    case Wednesday:
      cout << "Wednesday";
      break;

    case Thursday:
      cout << "Thursday";
      break;

    case Friday:
      cout << "Friday";
      break;

    case Saturday:
      cout << "Saturday";
      break;
  }

  if (bEmitCR)
    cout << endl;
}

void myDay::setDay(int nDayNum)
{
  if (nDayNum >= 0 && nDayNum < 7)
    m_eDay = weekDay(nDayNum);
  else
    m_eDay = Sunday;
}

void myDay::getNextAndPrevious(weekDay& eNextDay,
                               weekDay& ePrevDay)
{
  // get the next day
  if (m_eDay != Saturday)
    eNextDay = weekDay(int(m_eDay) + 1);
  else
    eNextDay = Sunday;

  // get the previous day
  if (m_eDay != Sunday)
    ePrevDay = weekDay(int(m_eDay) - 1);
  else
    ePrevDay = Saturday;
}

main()
{
  const int MAX = 3;
  myDay makeMyDay;
  weekDay eNextDay, ePrevDay;

  // reseed random-number generator
  srand((unsigned)time(NULL));
  for (int i = 0; i < MAX; i++) {
    // get random day number
    int n = rand() % 7;
    makeMyDay.setDay(n);
    // display today
    cout << "Day # " << (i+1) << endl;
    makeMyDay.show("Today is ");

    makeMyDay.getNextAndPrevious(eNextDay, ePrevDay);

    // display tomorrow
    makeMyDay.setDay(eNextDay);
    makeMyDay.show("Tomorrow is ");

    // display yesterday
    makeMyDay.setDay(ePrevDay);
    makeMyDay.show("Yesterday was ");
    cout << endl;
  }

  return 0;
}

