// A C++ program that illustrates
// exception classes, throwing exceptions,
// and catching exceptions

#include <iostream.h>

// declare a skeleton exception class
class error1 {};

// declare a non-skeleton exception class
class error2
{
  public:
    error2(int nCode)
      { m_nCode = nCode; }
    int m_nCode;
};

// declare a non-skeleton exception class
class error3
{
  public:
    error3()
      { m_nCode = 0; }
    void setCode(int nCode)
      { m_nCode = nCode; }
    int getCode()
      { return m_nCode; }
  protected:
    int m_nCode;
};

main()
{
  int nNum = 123;
  error2 errorObj2(100);
  error3 errorObj3;

  // test throwing a predefined-type object
  cout << "Testing throwing an int\n";
  try {
    throw nNum;
  }
  catch (int nCode)
  {
    cout << nCode << " is not a valid int\n";
  }
  catch (char cCode)
  {
    cout << cCode << " is not a valid char\n";
  }
  catch (long lCode)
  {
    cout << lCode << " is not a valid long\n";
  }

  // test throwing an error1 exception
  cout << "Testing throwing a error1 exception\n";
  try {
    throw error1();
  }
  catch (error1)
  {
    cout << "Handling error1 exception\n";
  }
  catch (char cCode)
  {
    cout << cCode << " is not a valid char\n";
  }
  catch (long lCode)
  {
    cout << lCode << " is not a valid long\n";
  }

    // test throwing error2 class
  cout << "Testing throwing an error2 exception\n";
  try {
    throw errorObj2;
  }
  catch (error2 err)
  {
    cout << "Handling error2 exception\n";
    cout << err.m_nCode << " is not a valid int\n";
  }
  catch (char cCode)
  {
    cout << cCode << " is not a valid char\n";
  }
  catch (long lCode)
  {
    cout << lCode << " is not a valid long\n";
  }

    // test throwing an error3 exception
  cout << "Testing throwing an error3 exception\n";
  try {
    errorObj3.setCode(nNum);
    throw errorObj3;
  }
  catch (error3 err)
  {
    cout << "Handling error3 exception\n";
    cout << err.getCode() << " in not a valid int\n";
  }
  catch (char cCode)
  {
    cout << cCode << " is not a valid char\n";
  }
  catch (long lCode)
  {
    cout << lCode << " is not a valid long\n";
  }

  return 0;
}

