// A C++ program that illustrates
// rethrowing exceptions

#include <iostream.h>

// declare skeleton exception classes
class mainError {};
class secError {};

void solver(int nCode)
{
  try {
    if (nCode >= 0)
      throw mainError();
    else
      throw secError();
  }
  catch(mainError)
  {
    cout << "Handling main exception "
         << "in function solver\n";
  }
  catch(...)
  {
    cout << "Cannot handle secondary exception "
         << "in function solver\n";
    // rethrow exception to caller
    throw;
  }
}

main()
{
  // throw an exception
  try {
    solver(1);
    solver(-1);
  }
  catch (mainError)
  {
    cout << "Handling main exception in function main\n";
  }
  catch (secError)
  {
    cout << "Handling secondary exception in function main\n";
  }
  catch(...)
  {
    cout << "This is the last resort to "
         << "solve your problems!\n";
  }

  return 0;
}

