// A C++ program that illustrates
// handling unexpected exceptions

#include <iostream.h>
#include <except.h>
#include <stdlib.h>

// declare skeleton exception classes
class mainError {};
class secError {};
class Kaboom {};

void badNews()
{
  throw Kaboom();
}

void solver(int nCode) throw(mainError, secError)
{
  if (nCode > 0)
    throw mainError();
  else if (nCode < 0)
    throw secError();
  badNews();
}

void myUnexpected()
{
  cout << "Handling unexpected exception!\n";
  exit(1); // exit with error code 1
}

main()
{
  set_unexpected(myUnexpected);
  // throw an exception
  try {
      solver(0);
  }
  catch (mainError)
  {
    cout << "Handling main exception\n";
  }
  catch (secError)
  {
    cout << "Handling secondary exception\n";
  }

  return 0;
}

