// A C++ program that illustrates
// text file stream input and output

#include <fstream.h>
#include <iomanip.h>
#include <string.h>

const int LINE_SIZE = 90;
const int FILENAME_SIZE = 64;

enum Logical { FALSE, TRUE };

class Translator
{
  public:
    Translator();
    void getInputFilename();
    void getOutputFilename();
    void getFindChar();
    void getReplChar();
    Logical Translate();

  protected:
    char m_cInputFilename[FILENAME_SIZE + 1];
    char m_cOutputFilename[FILENAME_SIZE + 1];
    char m_cFind;
    char m_cRepl;
};

Translator::Translator()
{
  strcpy(m_cInputFilename, "");
  strcpy(m_cOutputFilename, "");
  m_cFind = '\0';
  m_cRepl = '\0';
}

void Translator::getInputFilename()
{
  cout << "Enter input filename : ";
  cin.getline(m_cInputFilename, FILENAME_SIZE);
}

void Translator::getOutputFilename()
{
  cout << "Enter output filename : ";
  cin.getline(m_cOutputFilename, FILENAME_SIZE);
}

void Translator::getFindChar()
{
  cout << "Enter character to find : ";
  cin >> m_cFind;
}

void Translator::getReplChar()
{
  cout << "Enter character to replace : ";
  cin >> m_cRepl;
}

Logical Translator::Translate()
{
  fstream fin, fout;
  char cLine[LINE_SIZE + 1];

  if (strcmp(m_cInputFilename, "") == 0  ||
      strcmp(m_cOutputFilename, "") == 0 ||
      m_cFind == '\0'                    ||
      m_cRepl == '\0')
    return FALSE;

  // open input file stream
  fin.open(m_cInputFilename, ios::in);
  // open failed?
  if (!fin)
    return FALSE;
  // open output file stream
  fout.open(m_cOutputFilename, ios::out);
  if (!fout) {
    fin.close();
    return FALSE;
  }

  while (!fin.eof()) {
    fin.getline(cLine, LINE_SIZE);
    for (int i = 0; i < int(strlen(cLine)); i++)
      if (cLine[i] == m_cFind)
        cLine[i] = m_cRepl;
    // write to output file
    fout << cLine << endl;
    // echo to console
    cout << cLine << endl;
  }
  // close file stream buffers
  fin.close();
  fout.close();
  return TRUE;
}

main()
{
  Translator TR;

  TR.getInputFilename();
  TR.getOutputFilename();
  TR.getFindChar();
  TR.getReplChar();
  if (TR.Translate())
    cout << "\n\nTranslation successful!\n";
  else
    cout << "Translation failed\n";

  return 0;
}

