// A C++ program that illustrates recursive functions

#include <iostream.h>

// declare the prototypes for recursive functions
double recFactorial(int nNum);
double recSumOfInts(int nNum);

// declare the prototypes for nonrecursive functions
double factorial(int nNum);
double sumOfInts(int nNum);

main()
{
  int nNum;
  double fX;

  // prompt user to enter integer in the range of 3 to 10
  do {
    cout << "Enter an integer (between 3 and 10) : ";
    cin >> nNum;
    cout << "\n";
  } while (nNum < 3 || nNum > 10);

  cout << "Testing recursive factorial function\n";
  fX = recFactorial(nNum);
  cout << "Factorial of " << nNum << " = "
       << fX << "\n";
  fX = factorial(nNum);
  cout << "Factorial of " << nNum << " = "
       << fX << " (nonrecursive)\n\n";

  cout << "Testing recursive summation function\n";
  fX = recSumOfInts(nNum);
  cout << "Sum of 1 to " << nNum << " = "
       << fX << "\n";
  fX = sumOfInts(nNum);
  cout << "Sum of 1 to " << nNum << " = "
       << fX << " (nonrecursive)\n";

  return 0;
}

double recFactorial(int nNum)
{
  if (nNum > 1) {
    cout << "Recursive call with argument "
         << (nNum - 1) << "\n";
    return nNum * recFactorial(nNum - 1);
  }
  else
    return 1.0;
}

double recSumOfInts(int nNum)
{
  if (nNum > 1) {
    cout << "Recursive call with argument "
         << (nNum - 1) << "\n";
    return nNum + recSumOfInts(nNum - 1);
  }
  else
    return 1.0;
}

double factorial(int nNum)
{
  double fResult = 1.;

  for (int i = 1; i <= nNum; i++)
    fResult *= (double)i;

  return fResult;
}

double sumOfInts(int nNum)
{
  double fSum = 0.;

  for (int i = 1; i <= nNum; i++)
    fSum += (double)i;

  return fSum;
}

