// A C++ program that illustrates exiting functions

#include <iostream.h>
#include <math.h>

const double BAD_RESULT = -1.0e+30;

// declare the function prototypes
double polynomial(double x);
double factorial(int nNum);

main()
{
  const int FIRST_INT = -1;
  const int LAST_INT = 5;
  const double FIRST_DOUBLE = 0.0;
  const double LAST_DOUBLE = 10.0;
  const double INCREM_DOUBLE = 1.0;

  double fX;

  for (int i = FIRST_INT; i <= LAST_INT; i++)
    cout << "Factorial of " << i << " = "
         << factorial(i) << "\n";
  cout << "\n";

  fX = FIRST_DOUBLE;
  while (fX <= LAST_DOUBLE) {
    cout << "P(" << fX << ") = "
         << polynomial(fX) << "\n";
    fX += INCREM_DOUBLE;
  }

  return 0;
}

double polynomial(double x)
{
  const double TOLERANCE = 1.0e-8;
  double fTerm;
  double fSum = 1.0;
  double fChs = 1.0;

  // does x exceed 1?
  if (x > 1.0)
    // start loop
    for (int i = 1; ; i++) {
      // calculate term
      fTerm = i / pow(x, i);
      // is term too small?
      if (fTerm < TOLERANCE)
        return fSum; // return current sum
      // reverse sign for the current term
      fChs -= 1.;
      // update summation
      fSum += fChs * fTerm;
    }
  // function executes next statement only if x <= 1
  return BAD_RESULT;
}


double factorial(int nNum)
{
  double fResult = 1.0;

  // is argument less than 2?
  if (nNum < 2)
    return fResult; // return 1 for trivial argument

  // execute loop which calculates factorial
  // for nontrivial argument
  for (int i = 2; i <= nNum; i++)
    fResult *= i;

  return fResult;

}

