// A C++ program that illustrates overloading functions

#include <iostream.h>

// declare function prototypes
char getNextChar(const char c);
char getPrevChar(const char c);

int getAverage(const int nNum1, const int nNum2);
double getMean(const double fX1, const double fX2);

void show(const char c, const char* pszMsg = "");
void show(const int nNum, const char* pszMsg = "");
void show(const double fX, const char* pszMsg = "");

main()
{
  char cLetter;
  int nN1, nN2;
  double fX1, fX2;

  cout << "Enter a letter : ";
  cin >> cLetter;
  show(cLetter, "Input character is ");
  show(getNextChar(cLetter), "Next character is ");
  show(getPrevChar(cLetter), "Previous character is ");
  cout << "\n";

  cout << "Enter first integer : ";
  cin >> nN1;
  cout << "Enter second integer : ";
  cin >> nN2;
  show(getAverage(nN1, nN2), "Average integer = ");
  cout << "\n";

  cout << "Enter first number : ";
  cin >> fX1;
  cout << "Enter second number : ";
  cin >> fX2;
  show(getMean(fX1, fX2), "Average number = ");

  return 0;
}

char getNextChar(const char c)
{
  return c + 1;
}

char getPrevChar(const char c)
{
  return c - 1;
}

void show(const char c, const char* pszMsg)
{
  cout << pszMsg << c << "\n";
}


int getAverage(const int nNum1, const int nNum2)
{
  return (nNum1 + nNum2) / 2;
}

void show(const int nNum, const char* pszMsg)
{
  cout << pszMsg << nNum << "\n";
}

double getMean(const double fX1, const double fX2)
{
  return (fX1 + fX2) / 2;
}

void show(const double fX, const char* pszMsg)
{
  cout << pszMsg << fX << "\n";
}

