// A C++ program that illustrates functions
// with local automatic variables

#include <iostream.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

// declare function prototypes
int updateSums(double fX, int& nSum,
                double& fSumX, double& fSumXX);
int getStats(int nSum, double fSumX, double fSumXX,
              double& fMean, double& fSdev);
int testRandomNumbers();

main()
{
  // reseed random number generator
  srand((unsigned)time(NULL));

  cout << "Test #1\n";
  testRandomNumbers();

  cout << "Test #2\n";
  testRandomNumbers();

  cout << "Test #3\n";
  testRandomNumbers();

  return 0;
}

int updateSums(double fX, int& nSum,
                double& fSumX, double& fSumXX)
{
  // update statistical summations with data
  nSum++;
  fSumX += fX;
  fSumXX += fX * fX;
  return 0;
}

int getStats(int nSum, double fSumX, double fSumXX,
              double& fMean, double& fSdev)
{
  // calculate mean
  fMean = fSumX / nSum;
  // calculate std. deviation
  fSdev = sqrt((fSumXX - fSumX * fSumX / nSum)/(nSum - 1));
  return 0;
}

int testRandomNumbers()
{
  const int LO = 1;
  const int HI = 1000;
  const int MAX = 100;
  double fX, fMean, fSdev;
  // declare and initialize statistical summations
  int nSum = 0;
  double fSumX = 0.;
  double fSumXX = 0.;

  for (int i = 0; i < MAX; i++) {
    fX = double(rand() % HI + LO);
    updateSums(fX, nSum, fSumX, fSumXX);
  }
  // get the basic statistics
  getStats(nSum, fSumX, fSumXX, fMean, fSdev);
  cout << "Number of observations = " << nSum << "\n"
       << "Mean = " << fMean << "\n"
       << "Std. deviation = " << fSdev << "\n";
  return 0;
}

