// A C++ program that illustrates functions
// with local static variables

#include <iostream.h>
#include <math.h>

const double PI = 4 * atan(1);
const double INIT_SEED = 13.0;

// declare function prototypes
double getRunningSum(double x);
double random();
double cube(double x);
double fract(double x);

main()
{
  const int MAX_NUMS = 100;
  const int SHOW_INTERVAL = 20;
  double fX;

  for (int i = 0; i < MAX_NUMS; i++) {
    fX = random();
    if ((i+1) % SHOW_INTERVAL != 0)
      getRunningSum(fX);  // ignore function value
    else {
      cout << "Sample random number is "
           << fX << "\n"
           << "Current Average = "
           << getRunningSum(fX) / (i+1)
           << " (" << (i+1) << " points)\n";
    }
  }

  return 0;
}

double getRunningSum(double x)
{
  static double fSum = 0.;

  fSum += x;
  // return running sum
  return fSum;
}

double random()
{
  static double fSeed = INIT_SEED;

  // get the next pseudo-random number
  fSeed = fract(cube(fSeed + PI));
  // return number
  return fSeed;
}

double cube(double x)
{
  return x * x * x;
}

double fract(double x)
{
  return x - double(long(x));
}

