// A C++ program that illustrates the for loop

#include <iostream.h>
#include <math.h>

const double PI = 4 * atan(1);

class myRandomNumber
{
  public:
    myRandomNumber(double fInitSeed = 13);
    double getRandom();
    void testRandom(long lCount, double& fMean, double& fSdev);

  protected:
    double m_fSeed;

    double frac(double x);
    double sqr(double x);
    double cube(double x);
};

myRandomNumber::myRandomNumber(double fInitSeed)
{
  m_fSeed = fInitSeed;
}

double myRandomNumber::getRandom()
{
  m_fSeed = frac(cube(m_fSeed + PI));
  return m_fSeed;
}

void myRandomNumber::testRandom(long lCount, double& fMean,
                                double& fSdev)
{
  double fSumX = 0;
  double fSumXX = 0;
  double fX;

  if (lCount < 2)
    return;

  for (long i = lCount; i > 0; i--) {
    fX = getRandom();
    fSumX += fX;
    fSumXX += sqr(fX);
  }
  // calculate mean
  fMean = fSumX / lCount;
  // calculate std. deviation
  fSdev = sqrt((fSumXX - sqr(fSumX) / lCount) / (lCount - 1));
}

double myRandomNumber::frac(double x)
{
  int nInt = int(x);
  return x - nInt;
}

double myRandomNumber::sqr(double x)
{
  return x * x;
}


double myRandomNumber::cube(double x)
{
  return x * x * x;
}


main()
{
  myRandomNumber RN;
  double fMean;
  double fSdev;

  cout << "Sample random numbers are:\n";
  for (int i = 0; i < 5; i++)
    cout << RN.getRandom() << "\n";
  cout << "\n";

  for (long nNum = 100; nNum <= 10000; nNum *= 10) {
    RN.testRandom(nNum, fMean, fSdev);
    cout << "Sample size    = " << nNum << "\n"
         << "Mean           = " << fMean << "\n"
         << "Std. Deviation = " << fSdev << "\n\n";
  }

  return 0;
}

