// A C++ program that illustrates for loops
// that increment/decrement their control
// variables by more than 1

#include <iostream.h>

class SumOfNumbers
{
  public:
    void setLimits(const int nFirst,
                   const int nLast,
                   const int nStep = 1);
    double getSum();
    double getSumOfSquares();

  protected:
    int m_nFirst;
    int m_nLast;
    int m_nStep;

    double sqr(double x);
};

void SumOfNumbers::setLimits(const int nFirst,
                             const int nLast,
                             const int nStep)
{
  // verify sequence of range value
  // and assign the range to data members
  if (nFirst < nLast) {
    m_nFirst = nFirst;
    m_nLast = nLast;
  }
  else {
    m_nFirst = nLast;
    m_nLast = nFirst;
  }

  // verify step value and assign the step
  // to data member m_nStep
  if (nStep > 0)
    m_nStep = nStep;
  else
    m_nStep = 1;
}

double SumOfNumbers::getSum()
{
  double fSum = 0;

  for (int i = m_nFirst; i <= m_nLast; i += m_nStep)
    fSum += (double)i;

  return fSum;
}

double SumOfNumbers::getSumOfSquares()
{
  double fSum = 0;

  for (int i = m_nLast; i >= m_nFirst; i -= m_nStep)
    fSum += sqr(double(i));

  return fSum;
}

double SumOfNumbers::sqr(double x)
{
  return x * x;
}

main()
{
  SumOfNumbers SON;
  int nFirst = 1;
  int nLast = 100;

  cout << "For the range of " << nFirst
         << " to " << nLast << "\n";
  for (int nIncr = 1; nIncr < 5; nIncr++) {
    SON.setLimits(nFirst, nLast, nIncr);
    cout << "Sum of integers in increments of "
         << nIncr << " = " << SON.getSum() << "\n";
    cout << "Sum of squared integers in increments of "
         << nIncr << " = " << SON.getSumOfSquares()
         << "\n\n";
  }

  return 0;
}

