// A C++ program that illustrates a for loop
// that uses multiple loop control variables

#include <iostream.h>

class SumOfNumbers
{
  public:
    void setLimits(const int nFirst, const int nLast);
    double getSum();
    double getSumOfSquares();

  protected:
    int m_nFirst;
    int m_nLast;
    int m_nNumInts;

    double sqr(double x);
};

void SumOfNumbers::setLimits(const int nFirst,
                             const int nLast)
{
  // verify sequence of range value
  // and assign the range to data members
  if (nFirst < nLast) {
    m_nFirst = nFirst;
    m_nLast = nLast;
  }
  else {
    m_nFirst = nLast;
    m_nLast = nFirst;
  }

  m_nNumInts = m_nLast - m_nFirst + 1;
}

double SumOfNumbers::getSum()
{
  double fSum = 0;

  for (int i = m_nFirst, j = m_nLast;
       i < j;
       i++, j--)
    fSum += (double)i + double(j);

  // does the range of integers contain
  // an odd number of values
  if (m_nNumInts % 2 == 1)
    fSum += double(m_nFirst + m_nLast) / 2;

  return fSum;
}

double SumOfNumbers::getSumOfSquares()
{
  double fSum = 0;

  for (int i = m_nFirst, j = m_nLast;
       i < j;
       i++, j--)
    fSum += sqr(double(i)) + sqr(double(j));

  // does the range of integers contain
  // an odd number of values
  if (m_nNumInts % 2 == 1)
    fSum += sqr(double(m_nFirst + m_nLast)) / 2;

  return fSum;
}

double SumOfNumbers::sqr(double x)
{
  return x * x;
}

main()
{
  SumOfNumbers SON;
  int nFirst = 1;
  int nLast = 100;

  SON.setLimits(nFirst, nLast);
  cout << "For the range of " << nFirst
         << " to " << nLast << "\n";
  cout << "Sum of integers  = " << SON.getSum() << "\n";
  cout << "Sum of squared integers = "
       << SON.getSumOfSquares() << "\n";

  return 0;
}

