// A C++ program that demonstrates the
// single-alternative if statement

#include <iostream.h>

const int GOOD = 1;
const int BAD = 0;

class intRange
{
  public:
    intRange(int nFirst, int nLast);
    int setValue(int nNum);
    int getValue()
      { return m_nVal; }

  protected:
    int m_nFirst;
    int m_nLast;
    int m_nVal;
};

intRange::intRange(int nFirst, int nLast)
{
  // swap integers if nFirst > nLast
  if (nFirst > nLast) {
    int nSwap = nFirst;
    nFirst = nLast;
    nLast = nFirst;
  }

  m_nFirst = nFirst;
  m_nLast = nLast;
  m_nVal = m_nFirst;
}

int intRange::setValue(int nNum)
{
  int nResult = BAD;

  if (nNum >= m_nFirst && nNum <= m_nLast) {
    m_nVal = nNum;
    nResult = GOOD;
  }

  return nResult;
}

main()
{
  const int LO = 1;
  const int HI = 100;

  intRange intObj(LO, HI);
  int nNum;

  cout << "Object intObj stores "
       << intObj.getValue() << "\n";

  cout << "Enter an integer (between "
       << LO << " and " << HI << ") : ";
  cin >> nNum;

  if (intObj.setValue(nNum) == BAD)
    cout << "Your input was out of range!\n";

  cout << "Object intObj stores "
       << intObj.getValue() << "\n";

  return 0;
}

