// A C++ program that illustrates declaring
// and accessing multidimensional matrix elements

#include <iostream.h>
#include <stdio.h>
#include <iomanip.h>
#include <math.h>

const int MAX_ROWS = 3;
const int MAX_COLS = 3;

class myMatrix
{
  public:
    myMatrix(double fInitVal = 0);
    double& operator()(int nRow, int nCol)
      { return m_fMatrix[nRow][nCol]; }
    void show(const char* pszMsg = "",
              const int nNumRows = MAX_ROWS,
              const int nNumCols = MAX_COLS);

  protected:
    double m_fMatrix[MAX_ROWS][MAX_COLS];
};

myMatrix::myMatrix(double fInitVal)
{
  for (int i = 0; i < MAX_ROWS; i++)
    for (int j = 0; j < MAX_COLS; j++)
      m_fMatrix[i][j] = fInitVal;
}

void myMatrix::show(const char* pszMsg,
                    const int nNumRows,
                    const int nNumCols)
{
  char cString[10];

  cout << pszMsg << endl;
  for (int i = 0; i < nNumRows; i++) {
    for (int j = 0; j < nNumCols; j++) {
      sprintf(cString, "%3.1lf ", m_fMatrix[i][j]);
      cout << cString;
    }
    cout << endl;
  }
}

main()
{
  double fXMat[MAX_ROWS][MAX_COLS];
  myMatrix Matrix;
  int i, j;

  // initialize matrix fXMat
  for (i = 0; i < MAX_ROWS; i++)
    for (j = 0; j < MAX_COLS; j++)
      fXMat[i][j] = 2.0 + (double)(i * j);

  // assign values to object Matrix
  for (i = 0; i < MAX_ROWS; i++)
    for (j = 0; j < MAX_COLS; j++)
      Matrix(i, j) = sqrt(fXMat[i][j]);

  // show the matrix
  Matrix.show("Initial matrix is:");

  cout << endl;

  // double the values in object Matrix
  for (i = 0; i < MAX_ROWS; i++)
    for (j = 0; j < MAX_COLS; j++)
      Matrix(i, j) += Matrix(i, j);

  // show the matrix
  Matrix.show("After doubling values, matrix is:");

  return 0;
}

