// A C++ program that illustrates initializing
// multidimensional matrix elements

#include <iostream.h>
#include <stdio.h>
#include <iomanip.h>
#include <math.h>

const int MAX_ROWS = 2;
const int MAX_COLS = 5;

class myMatrix
{
  public:
    myMatrix(int bUseInitArray = 1, double fInitVal = 0);
    double& operator()(int nRow, int nCol)
      { return m_fMatrix[nRow][nCol]; }
    void show(const char* pszMsg = "",
              const int nNumRows = MAX_ROWS,
              const int nNumCols = MAX_COLS);

  protected:
    double m_fMatrix[MAX_ROWS][MAX_COLS];
};

myMatrix::myMatrix(int bUseInitArray, double fInitVal)
{
  if (bUseInitArray) {
    double fInitMat[MAX_ROWS][MAX_COLS] =
      { 1.9, 2.3, 7.6, 3.2, 6.7,
        2.9, 3.8, 8.7, 7.5, 4.5 };
    for (int i = 0; i < MAX_ROWS; i++)
      for (int j = 0; j < MAX_COLS; j++)
        m_fMatrix[i][j] = fInitMat[i][j];
  }
  else
    for (int i = 0; i < MAX_ROWS; i++)
      for (int j = 0; j < MAX_COLS; j++)
        m_fMatrix[i][j] = fInitVal;
}

void myMatrix::show(const char* pszMsg,
                    const int nNumRows,
                    const int nNumCols)
{
  char cString[10];

  cout << pszMsg << endl;
  for (int i = 0; i < nNumRows; i++) {
    for (int j = 0; j < nNumCols; j++) {
      sprintf(cString, "%3.1lf ", m_fMatrix[i][j]);
      cout << cString;
    }
    cout << endl;
  }
}

main()
{
  double fXMat[2][MAX_ROWS][MAX_COLS] =
      { // data for sub-array fMat[0][][]
        19.9, 29.3, 87.6, 43.2, 76.7,
        32.9, 43.8, 88.7, 87.5, 64.5,
        // data for sub-array fMat[1][][]
        111.9, 222.3, 777.6, 333.2, 676.7,
        222.9, 333.8, 688.7, 787.5, 484.5 };
  myMatrix Matrix;

  // show the matrix
  Matrix.show("Initial matrix is:");

  cout << endl;

  // update matrix Matrix
  for (int i = 0; i < MAX_ROWS; i++)
    for (int j = 0; j < MAX_COLS; j++)
      Matrix(i, j) = fXMat[1][i][j] / fXMat[0][i][j];

  // show the matrix
  Matrix.show("New matrix is:");

  return 0;
}

