// A C++ program that illustrates
// multidimensional array parameters

#include <iostream.h>
#include <iomanip.h>

const int MAX_ROWS1 = 3;
const int MAX_ROWS2 = 10;
const int MAX_COLS = 3;

void bubbleSort1(int nMatrix[MAX_ROWS1][MAX_COLS],
                 int nSortColIndex = 0,
                 int nNumRows = MAX_ROWS1,
                 int nNumCols = MAX_COLS);
void bubbleSort2(int nMatrix[][MAX_COLS],
                 int nSortColIndex,
                 int nNumRows, int nNumCols = MAX_COLS);
void copyMatrix(int nSourceMatrix[][MAX_COLS],
                int nTargetMatrix[][MAX_COLS],
                int nNumRows, int nNumCols);
void showMatrix(const char* pszMsg,
                int nMatrix[][MAX_COLS],
                int nNumRows, int nNumCols);

main()
{
  int nMatrix1[MAX_ROWS1][MAX_COLS] =
     { 41, 67, 55, 98, 12, 15, 10, 65, 48 };
  int nMatrix2[MAX_ROWS2][MAX_COLS];
  int nColIndex = 0;

  // copy elements of array nMatrix1 into  nMatrix2
  copyMatrix(nMatrix1, nMatrix2, MAX_ROWS1, MAX_COLS);

  // display unsorted matrix nMatrix1
  showMatrix("Unsorted matrix nMatrix1 is:\n",
             nMatrix1, MAX_ROWS1, MAX_COLS);
  // sort matrix nMatrix1
  bubbleSort1(nMatrix1);
  // display sorted matrix nMatrix1
  showMatrix("Sorted matrix nMatrix1 is:\n",
             nMatrix1, MAX_ROWS1, MAX_COLS);

  // copy elements of matrix nMatrix2 into  nMatrix1
  copyMatrix(nMatrix2, nMatrix1, MAX_ROWS1, MAX_COLS);
  // display unsorted matrix nMatrix1
  showMatrix("Unsorted matrix nMatrix1 is:\n",
             nMatrix1, MAX_ROWS1, MAX_COLS);
  // sort matrix nMatrix1
  bubbleSort2(nMatrix1, nColIndex, MAX_ROWS1, MAX_COLS);
  // display sorted matrix nMatrix1
  showMatrix("Sorted matrix nMatrix1 is:\n",
             nMatrix1, MAX_ROWS1, MAX_COLS);
  // sort matrix nMatrix2
  bubbleSort2(nMatrix2, nColIndex, MAX_ROWS1, MAX_COLS);
  // display sorted matrix nMatrix2
  showMatrix("Sorted matrix nMatrix2 is:\n",
             nMatrix2, MAX_ROWS1, MAX_COLS);

  return 0;
}

void bubbleSort1(int nMatrix[MAX_ROWS1][MAX_COLS],
                 int nSortColIndex,
                 int nNumRows, int nNumCols)
{
  int nSwap;

  for (int i = 0; i < (nNumRows - 1); i++)
    for (int j = i; j < nNumRows; j++)
      if (nMatrix[i][nSortColIndex] >
          nMatrix[j][nSortColIndex]) {
        for (int k = 0 ; k < nNumCols; k++) {
          nSwap = nMatrix[i][k];
          nMatrix[i][k] = nMatrix[j][k];
          nMatrix[j][k] = nSwap;
        }
      }
}

void bubbleSort2(int nMatrix[][MAX_COLS],
                 int nSortColIndex,
                 int nNumRows, int nNumCols)
{
  int nSwap;

  for (int i = 0; i < (nNumRows - 1); i++)
    for (int j = i; j < nNumRows; j++)
      if (nMatrix[i][nSortColIndex] >
          nMatrix[j][nSortColIndex]) {
        for (int k = 0 ; k < nNumCols; k++) {
          nSwap = nMatrix[i][k];
          nMatrix[i][k] = nMatrix[j][k];
          nMatrix[j][k] = nSwap;
        }
      }
}

void copyMatrix(int nSourceMatrix[][MAX_COLS],
                int nTargetMatrix[][MAX_COLS],
                int nNumRows, int nNumCols)
{
  for (int i = 0; i < nNumRows; i++)
    for (int j = 0; j < nNumCols; j++)
      nTargetMatrix[i][j] = nSourceMatrix[i][j];
}

void showMatrix(const char* pszMsg,
                int nMatrix[][MAX_COLS],
                int nNumRows, int nNumCols)
{
  cout << pszMsg;
  for (int i = 0; i < nNumRows; i++) {
    for (int j = 0; j < nNumCols; j++)
      cout << nMatrix[i][j] << ' ';
    cout << endl;
  }
  cout << endl;
}

