// A C++ program that illustrates
// the linear search algorithm for matrices

#include <iostream.h>
#include <iomanip.h>

const int MAX_ROWS = 5;
const int MAX_COLS = 3;
const int NOT_FOUND = -1;

class myMatrix
{
  public:
    myMatrix(int fInitVal = 0);
    int& operator()(int nRow, int nCol)
      { return m_nMatrix[nRow][nCol]; }
    void show(const char* pszMsg = "",
              const int nNumRows = MAX_ROWS,
              const int nNumCols = MAX_COLS);
    int linearSearch(int nKey,
                     int nColIndex = 0,
                     int nLastRow = MAX_ROWS - 1,
                     int nFirstRow = 0);

  protected:
    int m_nMatrix[MAX_ROWS][MAX_COLS];
};

myMatrix::myMatrix(int fInitVal)
{
  for (int i = 0; i < MAX_ROWS; i++)
    for (int j = 0; j < MAX_COLS; j++)
      m_nMatrix[i][j] = fInitVal;
}

void myMatrix::show(const char* pszMsg,
                    const int nNumRows,
                    const int nNumCols)
{
  cout << pszMsg << endl;
  for (int i = 0; i < nNumRows; i++) {
    for (int j = 0; j < nNumCols; j++)
      cout << m_nMatrix[i][j] << ' ';
    cout << endl;
    }
  cout << endl;
}

int myMatrix::linearSearch(int nKey, int nColIndex,
                           int nLastRow, int nFirstRow)
{
  for (int i = nFirstRow; i <= nLastRow; i++)
    if (m_nMatrix[i][nColIndex] == nKey)
      break;
  return (i <= nLastRow) ? i : NOT_FOUND;
}

main()
{
  int j, nColIndex = 0;
  int nMat[MAX_ROWS][MAX_COLS] =
      { 23, 45, 89, // row 0
        74, 51, 18, // row 1
        87, 63, 36, // row 2
        38, 15, 33, // row 3
        67, 93, 83  // row 4
      };

  myMatrix Matrix;

  for (int i = 0; i < MAX_ROWS; i++)
    for (int j = 0; j < MAX_COLS; j++)
      Matrix(i, j) = nMat[i][j];

  Matrix.show("Matrix is:");
  for (i = 0; i < MAX_ROWS; i += 2) {
    cout << "Searching for " << nMat[i][nColIndex]
         << " in column " << nColIndex << ": ";
    j = Matrix.linearSearch(nMat[i][nColIndex], nColIndex);
    if (j != NOT_FOUND)
      cout << "found match at row " << j << endl;
    else
      cout << "found no match\n";
  }
  return 0;
}

