// A C++ program that illustrates using pointers
// to arrays as parameters in functions

#include <iostream.h>
#include <iomanip.h>

const int TRUE = 1;
const int FALSE = 0;

// prototype functions
void showIntArray(int* pnArray, int nNumElems,
                  const char* pszMsg = "");
void CombSort(int* pnArray, int nNumElems);

main()
{
  int nArray1[] = { 65, 78, 22, 54, 56, 66 };
  int nArray2[] = { 265, 378, 522, 354, 156, 766,
                    888, 123, 111, 433, 445 };
  int nSize1 = sizeof(nArray1) / sizeof(int);
  int nSize2 = sizeof(nArray2) / sizeof(int);

  // displays unsorted first array
  showIntArray(nArray1, nSize1, "Unsorted first array is:\n");
  // sort first array
  CombSort(nArray1, nSize1);
  // displays sorted first array
  showIntArray(nArray1, nSize1, "Sorted first array is:\n");


  // displays unsorted second array
  showIntArray(nArray2, nSize2, "Unsorted second array is:\n");
  // sort second array
  CombSort(nArray2, nSize2);
  // displays sorted second array
  showIntArray(nArray2, nSize2, "Sorted second array is:\n");

  return 0;
}

void showIntArray(int* pnArray, int nNumElems,
                  const char* pszMsg)
{
  cout << pszMsg;
  for (int i = 0; i < nNumElems; i++)
    cout << pnArray[i] << ' ';
  cout << endl;
}

void CombSort(int* pnArray, int nNumElems)
{
  int nOffset = nNumElems;
  int bSorted;

  if (nNumElems < 2)
    return;

  do {
    nOffset = (nOffset * 8) / 11;
    nOffset = (nOffset < 1) ? 1 : nOffset;
    bSorted = TRUE; // set sorted flag
    // compare elements
    for (int i = 0, j = nOffset;
         i < (nNumElems - nOffset);
         i++, j++) {
      if (pnArray[i] > pnArray[j]) {
        // swap elements
        int nSwap = pnArray[i];
        pnArray[i] = pnArray[j];
        pnArray[j] = nSwap;
        bSorted = FALSE; // clear sorted flag
      }
    }
  } while (!bSorted || nOffset != TRUE);
}

