// A C++ program that illustrates pointers to enumerated types
// used as function parameters

#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <time.h>

// declare enumerated type
enum weekDay { Sunday, Monday, Tuesday, Wednesday,
               Thursday, Friday, Saturday };
enum Logical { FALSE, TRUE };

void showWeekDay(weekDay eDay,
                 const char* pszMsg = "",
                 Logical bEmitCR = TRUE);
void getNextAndPreviousDays(weekDay eDay,
                            weekDay* peNextDay,
                            weekDay* pePrevDay);


main()
{
  const int MAX = 3;
  weekDay Today, Tomorrow, Yesterday;

  // reseed random-number generator
  srand((unsigned)time(NULL));
  for (int i = 0; i < MAX; i++) {
    // get random day number
    int n = rand() % 7;
    Today = weekDay(n);
    // display today
    cout << "Day # " << (i+1) << endl;
    showWeekDay(Today, "Today is ");

    // display tomorrow
    getNextAndPreviousDays(Today, &Tomorrow, &Yesterday);
    showWeekDay(Tomorrow, "Tomorrow is ");

    // display yesterday
    showWeekDay(Yesterday, "Yesterday was ");
    cout << endl;
  }

  return 0;
}

void showWeekDay(weekDay eDay,
                 const char* pszMsg,
                 Logical bEmitCR)
{
  cout << pszMsg;
  switch (eDay) {
    case Sunday:
      cout << "Sunday";
      break;

    case Monday:
      cout << "Monday";
      break;

    case Tuesday:
      cout << "Tuesday";
      break;

    case Wednesday:
      cout << "Wednesday";
      break;

    case Thursday:
      cout << "Thursday";
      break;

    case Friday:
      cout << "Friday";
      break;

    case Saturday:
      cout << "Saturday";
      break;
  }

  if (bEmitCR)
    cout << endl;
}

void getNextAndPreviousDays(weekDay eDay,
                            weekDay* peNextDay,
                            weekDay* pePrevDay)
{
  switch (eDay) {
    case Sunday:
      *peNextDay = Monday;
      *pePrevDay = Saturday;
      break;

    case Monday:
      *peNextDay = Tuesday;
      *pePrevDay = Sunday;
      break;

    case Tuesday:
      *peNextDay = Wednesday;
      *pePrevDay = Monday;
      break;

    case Wednesday:
      *peNextDay = Thursday;
      *pePrevDay = Tuesday;
      break;

    case Thursday:
      *peNextDay = Friday;
      *pePrevDay = Wednesday;
      break;

    case Friday:
      *peNextDay = Saturday;
      *pePrevDay = Thursday;
      break;

    case Saturday:
      *peNextDay = Sunday;
      *pePrevDay = Friday;
      break;
  }
}

