// A C++ program that illustrates pointers to functions

#include <iostream.h>
#include <iomanip.h>

const int MAX_ELEMS = 10;

enum Logical { FALSE, TRUE };

// declare prototypes
void ShellSort(int* pnArray, int nNumElems);
void CombSort(int* pnArray, int nNumElems);
void showIntArray(int* pnArray,
                  const int nNumElems,
                  const char* pszMsg = "" );

main()
{
  int nArr[MAX_ELEMS] = { 23, 45, 89, 74, 51,
                          18, 87, 63, 36, 38 };
  int nArray1[MAX_ELEMS];
  int nArray2[MAX_ELEMS];
  // declare pointer to function
  void (*pSort)(int*, int);

  // assign values to array nArray1 and nArray2
  // based on the values in array nArr
  for (int i = 0; i < MAX_ELEMS; i++) {
    nArray1[i] = (5 * nArr[i]) / 3;
    nArray2[i] = (3 * nArr[i]) / 2;
  }

  showIntArray(nArray1, MAX_ELEMS, "Unsorted first array is:");
  // assign the address of the CombSort to function pointer pSort
  pSort = CombSort;
  (*pSort)(nArray1, MAX_ELEMS);
  showIntArray(nArray1, MAX_ELEMS, "Sorted first array is:");

  showIntArray(nArray2, MAX_ELEMS, "Unsorted second array is:");
  // assign the address of the CombSort to function pointer pSort
  pSort = ShellSort;
  (*pSort)(nArray2, MAX_ELEMS);
  showIntArray(nArray2, MAX_ELEMS, "Sorted second array is:");

  return 0;
}

void ShellSort(int* pnArray, int nNumElems)
{
  int nOffset = nNumElems;
  int bSorted;

  if (nNumElems < 2)
    return;

  while (nOffset > 1) {
    nOffset = (nOffset - 1) / 3;
    nOffset = (nOffset < 1) ? 1 : nOffset;
    // arrange elements that are nOffset apart
    do {
      bSorted = TRUE; // set sorted flag
      // compare elements
      for (int i = 0, j = nOffset;
           i < (nNumElems - nOffset);
           i++, j++) {
        if (pnArray[i] > pnArray[j]) {
          // swap elements
          int nSwap = pnArray[i];
          pnArray[i] = pnArray[j];
          pnArray[j] = nSwap;
          bSorted = FALSE; // clear sorted flag
        }
      }
    } while (!bSorted);
  }
}

void CombSort(int* pnArray, int nNumElems)
{
  int nOffset = nNumElems;
  int bSorted;

  if (nNumElems < 2)
    return;

  do {
    nOffset = (nOffset * 8) / 11;
    nOffset = (nOffset < 1) ? 1 : nOffset;
    bSorted = TRUE; // set sorted flag
    // compare elements
    for (int i = 0, j = nOffset;
         i < (nNumElems - nOffset);
         i++, j++) {
      if (pnArray[i] > pnArray[j]) {
        // swap elements
        int nSwap = pnArray[i];
        pnArray[i] = pnArray[j];
        pnArray[j] = nSwap;
        bSorted = FALSE; // clear sorted flag
      }
    }
  } while (!bSorted || nOffset != TRUE);
}

void showIntArray(int* pnArray,
                  const int nNumElems,
                  const char* pszMsg)
{
  cout << pszMsg << endl;
  for (int i = 0; i < nNumElems; i++)
    cout << pnArray[i] << ' ';
  cout << endl;
}

