// A C++ program that illustrates
// pointers to classes

#include <iostream.h>
#include <iomanip.h>

const int MAX_ELEMS = 10;

class myArray
{
  public:
    myArray(int fInitVal = 0);
    int& operator[](int nIndex)
      { return m_nArray[nIndex]; }
    void show(const char* pszMsg = "",
              const int nNumElems = MAX_ELEMS,
              const int bOneLine = 1);
    void ShellSort(int nNumElems = MAX_ELEMS);

  protected:
    int m_nArray[MAX_ELEMS];
};

myArray::myArray(int fInitVal)
{
  for (int i = 0; i < MAX_ELEMS; i++)
    m_nArray[i] = fInitVal;
}

void myArray::show(const char* pszMsg,
                   const int nNumElems,
                   const int bOneLine)
{
  cout << pszMsg << endl;
  if (bOneLine) {
    for (int i = 0; i < nNumElems; i++)
      cout << m_nArray[i] << ' ';
    cout << endl;
  }
  else {
    for (int i = 0; i < nNumElems; i++)
      cout << m_nArray[i] << endl;
    cout << endl;
  }
}

void myArray::ShellSort(int nNumElems)
{
  int nOffset = nNumElems;
  int bSorted;

  if (nNumElems < 2)
    return;

  while (nOffset > 1) {
    nOffset = (nOffset - 1) / 3;
    nOffset = (nOffset < 1) ? 1 : nOffset;
    // arrange elements that are nOffset apart
    do {
      bSorted = 1; // set sorted flag
      // compare elements
      for (int i = 0, j = nOffset;
           i < (nNumElems - nOffset);
           i++, j++) {
        if (m_nArray[i] > m_nArray[j]) {
          // swap elements
          int nSwap = m_nArray[i];
          m_nArray[i] = m_nArray[j];
          m_nArray[j] = nSwap;
          bSorted = 0; // clear sorted flag
        }
      }
    } while (!bSorted);
  }
}

main()
{
  int nArr[MAX_ELEMS] = { 23, 45, 89, 74, 51,
                          18, 87, 63, 36, 38 };
  myArray Array;
  myArray* pArray = &Array;

  for (int i = 0; i < MAX_ELEMS; i++)
    pArray->operator[](i) = nArr[i];

  pArray->show("Unsorted array is:");
  pArray->ShellSort();
  pArray->show("Sorted array is:");

  return 0;
}

