// A C++ program that illustrates structures as classes

#include <iostream.h>
#include <string.h>

struct myObject
{
    myObject(const char* pszName, const long lValue = 0);
    ~myObject();
    void setValue(const long lNewValue = 0)
      { m_lVal = lNewValue; }
    long getValue()
      { return m_lVal; }

  protected:
    long m_lVal;
    char m_cName[30];
};

myObject::myObject(const char* pszName, const long lValue)
{
  // copy the object name to member m_cName
  strcpy(m_cName, pszName);
  cout << "Creating instance " << m_cName << "\n";
  m_lVal = lValue;
}

myObject::~myObject()
{
  cout << "Removing instance " << m_cName << "\n";
}

main()
{
  myObject obj1("obj1", 100);

  cout << "obj1 stores " << obj1.getValue() << "\n";

  { // block # 1
    myObject obj2("obj2", 200);

    cout << "obj2 stores " << obj2.getValue() << "\n";

    {  // block # 2
      myObject obj3("obj3", 300);
      myObject obj4("obj4", 400);

      cout << "obj3 stores " << obj3.getValue() << "\n";
      cout << "obj4 stores " << obj4.getValue() << "\n";
    }

    { // block # 3
      myObject obj5("obj5", 500);
      myObject obj6("obj6", 600);

      cout << "obj5 stores " << obj5.getValue() << "\n";
      cout << "obj6 stores " << obj6.getValue() << "\n";
    }
  }

  return 0;
}

