// A C++ program that illustrates
// function templates

#include <iostream.h>
#include <iomanip.h>

class myInt
{
  public:
    myInt(int nInt = 0)
      { m_nInt = nInt; }
    myInt& operator =(myInt& intObj);
    myInt& operator =(int nInt);
    friend int operator >(myInt& intObj1, myInt& intObj2)
      { return (intObj1.m_nInt > intObj2.m_nInt) ? 1 : 0; }
    int getInt()
      { return m_nInt; }
    void show(const char* pszMsg = "")
      { cout << pszMsg << m_nInt << endl; }

  protected:
    int m_nInt;
};

myInt& myInt::operator =(myInt& intObj)
{
  m_nInt = intObj.m_nInt;
  return *this;
}

myInt& myInt::operator =(int nInt)
{
  m_nInt = nInt;
  return *this;
}

template <class T>
T getMin(T& Value1, T& Value2)
{
  return (Value1 > Value2) ? Value2 : Value1;
}

main()
{
  int nNum1 = 100;
  int nNum2 = 22;
  int nNum3;

  myInt intObj1, intObj2, intObj3;

  intObj1 = nNum1;
  intObj2 = nNum2;
  // get the smallest int using function template
  nNum3 = getMin(nNum1, nNum2);
  // get the smallest integer object using function template
  intObj3 = getMin(intObj1, intObj2);

  cout << "Integer 1 is " << nNum1 << endl;
  cout << "Integer 2 is " << nNum2 << endl;
  cout << "The smaller integer is " << nNum3 << endl;

  intObj1.show("Integer object 1 is ");
  intObj2.show("Integer object 2 is ");
  intObj3.show("The smaller integer object is ");

  return 0;
}

