// A C++ program that illustrates
// using the typedef statement

#include <iostream.h>
#include <iomanip.h>

typedef int CountType;
const CountType MAX_ELEMS = 10;

typedef int IndexType;
typedef int ValueType;
typedef int Boolean;
typedef void Procedure;
typedef const char* MessageType;
typedef int IntArrayType[MAX_ELEMS];


const IndexType NOT_FOUND = -1;

class myArray
{
  public:
    myArray(ValueType fInitVal = 0);
    ValueType& operator[](IndexType nIndex)
      { return m_nArray[nIndex]; }
    Procedure show(MessageType pszMsg = "",
                   const CountType nNumElems = MAX_ELEMS,
                   const Boolean bOneLine = 1);
    IndexType linearSearch(ValueType nKey,
                           IndexType nLast = MAX_ELEMS - 1,
                           IndexType nFirst = 0);

  protected:
    IntArrayType m_nArray;
};

myArray::myArray(ValueType fInitVal)
{
  for (IndexType i = 0; i < MAX_ELEMS; i++)
    m_nArray[i] = fInitVal;
}

Procedure myArray::show(MessageType pszMsg,
                        const CountType nNumElems,
                        const Boolean bOneLine)
{
  cout << pszMsg << endl;
  if (bOneLine) {
    for (IndexType i = 0; i < nNumElems; i++)
      cout << m_nArray[i] << ' ';
    cout << endl;
  }
  else {
    for (IndexType i = 0; i < nNumElems; i++)
      cout << m_nArray[i] << endl;
    cout << endl;
  }
}

IndexType myArray::linearSearch(ValueType nKey,
                                       IndexType nLast,
                                       IndexType nFirst)
{
  for (IndexType i = nFirst; i <= nLast; i++)
    if (m_nArray[i] == nKey)
      break;
  return (i <= nLast) ? i : NOT_FOUND;
}

main()
{
  IndexType j;
  IntArrayType nArr = { 23, 45, 89, 74, 51,
                          18, 87, 63, 36, 38 };
  myArray Array;

  for (IndexType i = 0; i < MAX_ELEMS; i++)
    Array[i] = nArr[i];

  Array.show("Array is:");
  for (i = 0; i < MAX_ELEMS; i += 3) {
    cout << "Searching for " << nArr[i];
    j = Array.linearSearch(nArr[i]);
    if (j != NOT_FOUND)
      cout << " found match at index " << j << endl;
    else
      cout << " found no match\n";
  }
  return 0;
}

